//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                        Quantum London Trading EA |
//|                                      Copyright 2012, CompanyName |
//|              http://www.forexfactory.com/showthread.php?t=552185 |
//+------------------------------------------------------------------+ 
#import "user32.dll"
int MessageBoxA(int Ignore,string Caption,string Title,int Icon);
#import
#property strict
#property link "http://www.forexfactory.com/showthread.php?t=551382"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum enum_QT
  {
   Quantum=1,
   QuantumStochasticOB_OS=2,
  };

input int mn=2015; //Magic Number
input string comm="Quantum London Trading EA";//Order Comment
input enum_QT QT=1;//Quantum Indicator
input string qq="-----------";//If using QuantumStochasticOB_OS -
input int K = 5;
input int D = 3;
input int S = 3;
input int OS = 20;
input int OB = 80;
input string qr="-----------";//If using Quantum
input int qde=250;//Quantum eintDepth3 for Entry
input int qdc=100;//Quantum eintDepth3 for Close
input string qt="-----------"; //Trades entering setting
input int ema=0;// Daily EMA Filter Period
input bool had=false;//Weekly Heiken Ashi Filter
input int wait=0;//Wait X boxes before opening trades
input int xcandles=0;//Only trade every X candles
input int xdist=0;//Minimum distance between entries
input bool reverse=false;//Reverse Trading (Buy on Red, Sell on Blue)
input string or="-----------";//-----------
input string open1="00:00"; // Trading Window Start Time (Broker)
input string close1="23:59"; // Trading Window End Time (Broker)
input int max1=0;//Max Trades within Trading Window Time
input int cyc1=0;//Max Cycles within Trading Window Time
input bool closeend=false;//Close all trades at Trading Window End Time
input bool onlylowerhigher=false;//Only open higher (sells) or lower (buys) than previous order
input int tf=1;//Time Frame (minutes)
input bool fifo=false;//Use FIFO Rule
input bool mon=true;//Trade on Monday
input bool tue=true;//Trade on Tuesday
input bool wed=true;//Trade on Wednesday
input bool thurs=true;//Trade on Thursday
input bool fri=true;//Trade on Friday
input string awa="------------------------------------------------------";
input string axa="-------  CHOOSE LOT WISELY AND MARKET ENTRY    -------";
input string aya="------------------------------------------------------";
input double lot1=0.01; //Lot Trade 1
input double lot2=0.01; //Lot Trade 2
input double lot3=0.01; //Lot Trade 3
input double lot4=0.01; //Lot Trade 4
input double lot5=0.01; //Lot Trade 5
input double lot6=0.01; //Lot Trade 6
input double lot7=0.01; //Lot Trade 7
input double lot8=0.01; //Lot Trade 8
input double lot9=0.01; //Lot Trade 9
input double lot10=0.01; //Lot Trade 10
input double lot11=0.01; //Lot Trade 11
input double lot12=0.01; //Lot Trade 12
input double lot13=0.01; //Lot Trade 13
input double lot14=0.01; //Lot Trade 14
input double lot15=0.01; //Lot Trade 15
input double lot16=0.01; //Lot Trade 16
input double lot17=0.01; //Lot Trade 17
input double lot18=0.01; //Lot Trade 18
input double lot19=0.01; //Lot Trade 19
input double lot20=0.01; //Lot Trade 20
input double lot21=0.01; //Lot Trade 21
input double lot22=0.01; //Lot Trade 22
input double lot23=0.01; //Lot Trade 23
input double lot24=0.01; //Lot Trade 24
input double lot25=0.01; //Lot Trade 25
input double lot26=0.01; //Lot Trade 26
input double lot27=0.01; //Lot Trade 27
input double lot28=0.01; //Lot Trade 28
input double lot29=0.01; //Lot Trade 29
input double lot30=0.01; //Lot Trade 30
input double lot31=0.01; //Lot Trade 31
input double lot32=0.01; //Lot Trade 32
input double lot33=0.01; //Lot Trade 33
input double lot34=0.01; //Lot Trade 34
input double lot35=0.01; //Lot Trade 35
input double lot36=0.01; //Lot Trade 36
input double lot37=0.01; //Lot Trade 37
input double lot38=0.01; //Lot Trade 38
input double lot39=0.01; //Lot Trade 39
input double lot40=0.01; //Lot Trade 40
input double lot41=0.05; //Lot Trade 41
input double lot42=0.1;  //Lot Trade 42 & >
input double indivtp=0;//Take Profit Points Per Trade
input double indivsl=0;//Stop Loss Points Per Trade
input int pointstp=0;//Points Take Profit (Eg. 100)
input double dollartp=0;//$ Take Profit (Eg. 100)
input double percequitytp=0;//% Equity Take Profit (Eg. 10)
input int pointssl=0;//Points Stop Loss (Eg. -100)
input double dollarsl=0;//$ Stop Loss (Eg. -50)
input double percequitysl=0;//% Equity Stop Loss (Eg. -10)
input int closex=0;//Close after X trades

double lots,prevorderprice;
datetime curtime,prevtime,curday,prevday;
bool donefortheday,buys,buyclosed,sellclosed;
double initialstartbuy,initialstartsell;
double digits;
int openorders,mt1,thewait,cycles,c1;

//+------------------------------------------------------------------+
int init()
{
   return(0);
}
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+

int start()
// Main Iteration Start
{
   digits=1;
   if(IsTradeAllowed()==false)
      Alert("Broker does not allow EA to trade");

   curday=iTime(Symbol(),PERIOD_D1,0);

   if(curday>prevday)
   {
      cycles=0;
      prevday=iTime(Symbol(),PERIOD_D1,0);
   }

   CheckCloseTrades();

   openorders=0;
   for(int j=OrdersTotal()-1;j>=0;j--)
   {
      if(!OrderSelect(j,SELECT_BY_POS,MODE_TRADES))
      continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
      {
         openorders+=1;
      }
   }

   //Open trades after Trading Window Start Time and before Trading Window End Time
   for(int i=OrdersTotal()-1;i>=0;i--)
   {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
      {
         prevorderprice=OrderOpenPrice();
         break;
      }
   }

   bool buttonstarted=ObjectGetInteger(0,"start",OBJPROP_STATE);

   if(QT==1)
   {
      if(iCustom(Symbol(),tf,"Quantum",qde,0,1)>0 && buys==false)
      {
         buys=true;
         thewait=0;
      }
      if(iCustom(Symbol(),tf,"Quantum",qde,1,1)>0 && buys==true)
      {
         buys=false;
         thewait=0;
      }
   }
   if(QT==2)
   {
      if(iCustom(Symbol(),tf,"Quantum - Stochastic OB_OS",qde,K,D,S,OS,OB,0,1)>0 && buys==false)
      {
         buys=true;
         thewait=0;
      }
      if(iCustom(Symbol(),tf,"Quantum - Stochastic OB_OS",qde,K,D,S,OS,OB,1,1)>0 && buys==true)
      {
         buys=false;
         thewait=0;
      }
   }

   curtime=iTime(Symbol(),tf,0);
   
   if(openorders<=0 || openorders>0)
   //iteration 0 start
   {
      if((cycles<cyc1 && cyc1>0) || cyc1<=0)
      //iteration 1 start
      {
      
         if((iTime(Symbol(),1,0)>=StrToTime(open1) && iTime(Symbol(),1,0)<StrToTime(close1)) && curtime>prevtime)
         //iteration 2 start
         {
         
            bool cantrade=true;
         
            if(((iCustom(Symbol(),tf,"Quantum",qde,0,1)>0 && reverse==false && QT==1) || (iCustom(Symbol(),tf,"Quantum - Stochastic OB_OS",qde,K,D,S,OS,OB,0,1)>0 && reverse==false && QT==2) || (iCustom(Symbol(),tf,"Quantum",qde,1,1)>0 && reverse && QT==1) || (iCustom(Symbol(),tf,"Quantum - Stochastic OB_OS",qde,K,D,S,OS,OB,1,1)>0 && reverse && QT==2)) && buyclosed==false)
            //iteration 3_1 start
            {
            
               if((Bid>iMA(Symbol(),PERIOD_D1,ema,0,MODE_EMA,PRICE_CLOSE,1) && ema>0) || ema<=0)
               //iteration 3_2 start
               {
               
                  sellclosed=false;
                  if(wait>0 && thewait<wait)
                  //iteration 3_3 start
                  {
                     thewait+=1;
                  }
                  //iteration 3_3 end
                  else
                  //iteration 3_4 start
                  {
                     if(mon==false && DayOfWeek()==1)
                        cantrade=false;
                     if(tue==false && DayOfWeek()==2)
                        cantrade=false;
                     if(wed==false && DayOfWeek()==3)
                        cantrade=false;
                     if(thurs==false && DayOfWeek()==4)
                        cantrade=false;
                     if(fri==false && DayOfWeek()==5)
                        cantrade=false;

                     if(prevorderprice-(xdist*Point)<=Ask && xdist>0 && prevorderprice>0)
                        cantrade=false;

                     //Heiken Ashi Filter
                     if(iCustom(Symbol(),PERIOD_W1,"Heiken Ashi",Red,White,Red,White,2,0)>iCustom(Symbol(),0,"Heiken Ashi",Red,White,Red,White,3,0) && had)
                        cantrade=false;

                     if(xcandles>0)
                     {
                        int lastorderbar;
                        for(int i=OrdersTotal()-1;i>=0;i--)
                        {
                           if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
                           continue;
                           if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
                           {
                              lastorderbar=iBarShift(Symbol(),tf,OrderOpenTime(),false);
                              break;
                           }
                        }
                        if(lastorderbar<xcandles && lastorderbar>0)
                        {
                           cantrade=false;
                        }
                     }
                  
                     mt1 = 0;
                  
                     for(int t=OrdersHistoryTotal()-1;t>=0;t--)
                     {
                        if(!OrderSelect(t,SELECT_BY_POS,MODE_HISTORY))
                           continue;
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn && OrderOpenTime()>=iTime(Symbol(),PERIOD_D1,0))
                        {
                           if(OrderOpenTime()>=StrToTime(open1) && OrderOpenTime()<StrToTime(close1))
                           mt1+=1;
                        }
                     }
                     for(int r=OrdersTotal()-1;r>=0;r--)
                     {
                        if(!OrderSelect(r,SELECT_BY_POS,MODE_TRADES))
                        continue;
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn && OrderOpenTime()>=iTime(Symbol(),PERIOD_D1,0))
                        {
                           if(OrderOpenTime()>=StrToTime(open1) && OrderOpenTime()<StrToTime(close1))
                           mt1+=1;
                        }
                     }
                     if((iTime(Symbol(),1,0)>=StrToTime(open1) && iTime(Symbol(),1,0)<StrToTime(close1)) && mt1>=max1 && max1>0)
                        cantrade=false;

                     if(Ask>prevorderprice && onlylowerhigher)
                        cantrade=false;

                     if(cantrade==true)
                     //iteration 3_5 start
                     {
                        lots=GetLots(Ask,"Buy");
                        if(lots>0)
                        //iteration 3_6 start
                        {
                           int ticket;
                           RefreshRates();
                           if(indivsl>0 || indivtp>0)
                           {
                              double newsl=0;
                              double newtp=0;
                              if(indivsl>0)
                                 newsl=NormalizeDouble(Ask-(indivsl*Point),Digits);
                              if(indivtp>0)
                                 newtp=NormalizeDouble(Ask+(indivtp*Point),Digits);
                              ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,5,newsl,newtp,comm,mn,0,0);
                           }
                           else
                           {
                              ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,5,0,0,comm,mn,0,0);
                           }
                           if(ticket<=-1)
                           {
                              RefreshRates();
                              if(indivsl>0 || indivtp>0)
                              {
                                 double newsl=0;
                                 double newtp=0;
                                 if(indivsl>0)
                                    newsl=NormalizeDouble(Ask-(indivsl*Point),Digits);
                                 if(indivtp>0)
                                    newtp=NormalizeDouble(Ask+(indivtp*Point),Digits);
                                 ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,5,newsl,newtp,comm,mn,0,0);
                              }
                              else
                              {
                                 ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,5,0,0,comm,mn,0,0);
                              }
                           }
                           
                           if(ticket<=-1)
                              Alert("OrderSend Error: ",GetLastError());
                        }
                        //iteration 3_6 end
                        
                        int bopenorders;
                        for(int s=OrdersTotal()-1;s>=0;s--)
                        {
                           if(!OrderSelect(s,SELECT_BY_POS,MODE_TRADES))
                              continue;
                           if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
                           {
                              bopenorders+=1;
                           }
                        }
                        if(bopenorders<=1 && bopenorders>0)
                        {
                           initialstartbuy=Ask;
                           initialstartsell=0;
                        }
                     }
                     //iteration 3_5 end  
                  }
                  //iteration 3_4 end
               }
               //iteration 3_2 end
            }
            //iteration 3_1 end
         
            if(((iCustom(Symbol(),tf,"Quantum",qde,1,1)>0 && reverse==false && QT==1) || (iCustom(Symbol(),tf,"Quantum",qde,0,1)>0 && reverse && QT==1) || (iCustom(Symbol(),tf,"Quantum - Stochastic OB_OS",qde,K,D,S,OS,OB,1,1)>0 && reverse==false && QT==2) || (iCustom(Symbol(),tf,"Quantum - Stochastic OB_OS",qde,K,D,S,OS,OB,0,1)>0 && reverse && QT==2)) && sellclosed==false)
            //iteration 4_1 start
            {
               if((Bid<iMA(Symbol(),PERIOD_D1,ema,0,MODE_EMA,PRICE_CLOSE,1) && ema>0) || ema<=0)
               //iteration 4_2 start
               {
                  buyclosed=false;
                  if(wait>0 && thewait<wait)
                  //iteration 4_3 start
                  {
                     thewait+=1;
                  }
                  //iteration 4_3 end
                  else
                  //iteration 4_4 start
                  {
                     if(mon==false && DayOfWeek()==1)
                        cantrade=false;
                     if(tue==false && DayOfWeek()==2)
                        cantrade=false;
                     if(wed==false && DayOfWeek()==3)
                        cantrade=false;
                     if(thurs==false && DayOfWeek()==4)
                        cantrade=false;
                     if(fri==false && DayOfWeek()==5)
                        cantrade=false;

                     if(prevorderprice+(xdist*Point)>=Bid && xdist>0 && prevorderprice>0)
                        cantrade=false;

                     //Heiken Ashi Filter
                     if(iCustom(Symbol(),PERIOD_W1,"Heiken Ashi",Red,White,Red,White,2,0)<iCustom(Symbol(),0,"Heiken Ashi",Red,White,Red,White,3,0) && had)
                     cantrade=false;

                     if(xcandles>0)
                     {
                        OrderSelect(OrdersTotal()-1,SELECT_BY_POS,MODE_TRADES);
                        int lastorderbar;
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
                        {
                           lastorderbar=iBarShift(Symbol(),tf,OrderOpenTime(),false);
                        }
                        if(lastorderbar<xcandles && lastorderbar>0)
                        {
                           cantrade=false;
                        }
                     }

                     mt1 = 0;
                  
                     for(int t=OrdersHistoryTotal()-1;t>=0;t--)
                     {
                        if(!OrderSelect(t,SELECT_BY_POS,MODE_HISTORY))
                           continue;
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn && OrderOpenTime()>=iTime(Symbol(),PERIOD_D1,0))
                        {
                           if(OrderOpenTime()>=StrToTime(open1) && OrderOpenTime()<StrToTime(close1))
                              mt1+=1;
                        }
                     }
                     for(int r=OrdersTotal()-1;r>=0;r--)
                     {
                        if(!OrderSelect(r,SELECT_BY_POS,MODE_TRADES))
                           continue;
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn && OrderOpenTime()>=iTime(Symbol(),PERIOD_D1,0))
                        {
                           if(OrderOpenTime()>=StrToTime(open1) && OrderOpenTime()<StrToTime(close1))
                              mt1+=1;
                        }
                     }

                     if(iTime(Symbol(),1,0)>=StrToTime(open1) && iTime(Symbol(),1,0)<StrToTime(close1) && mt1>=max1 && max1>0)
                        cantrade=false;
                     
                     if(Bid<prevorderprice && onlylowerhigher)
                        cantrade=false;

                     if(cantrade==true)
                     //iteration 4_5 start
                     {
                        lots=GetLots(Bid,"Sell");
                        
                        if(lots>0)
                        //iteration 4_6 start
                        {
                           int ticketn;
                           RefreshRates();
                           if(indivsl>0 || indivtp>0)
                           {
                              double newsl=0;
                              double newtp=0;
                              if(indivsl>0)
                                 newsl=NormalizeDouble(Bid+(indivsl*Point),Digits);
                              if(indivtp>0)
                              newtp=NormalizeDouble(Bid-(indivtp*Point),Digits);
                              ticketn=OrderSend(Symbol(),OP_SELL,lots,Bid,5,newsl,newtp,comm,mn,0,0);
                           }
                           else
                           {
                              ticketn=OrderSend(Symbol(),OP_SELL,lots,Bid,5,0,0,comm,mn,0,0);
                           }
                           if(ticketn<=-1)
                           {
                              RefreshRates();
                              if(indivsl>0 || indivtp>0)
                              {
                                 double newsl=0;
                                 double newtp=0;
                                 if(indivsl>0)
                                    newsl=NormalizeDouble(Bid+(indivsl*Point),Digits);
                                 if(indivtp>0)
                                    newtp=NormalizeDouble(Bid-(indivtp*Point),Digits);
                                 ticketn=OrderSend(Symbol(),OP_SELL,lots,Bid,5,newsl,newtp,comm,mn,0,0);
                              }
                              else
                              {
                                 ticketn=OrderSend(Symbol(),OP_SELL,lots,Bid,5,0,0,comm,mn,0,0);
                              }
                           }
                        
                           if(ticketn<=-1)
                              Alert("OrderSend Error: ",GetLastError());
                        }
                        //iteration 4_6 end
                        
                        int sopenorders;
                        for(int v=OrdersTotal()-1;v>=0;v--)
                        {
                           if(!OrderSelect(v,SELECT_BY_POS,MODE_TRADES))
                              continue;
                           if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
                           {
                              sopenorders+=1;
                           }
                        }
                        if(sopenorders<=1 && sopenorders>0)
                        {
                           initialstartsell=Bid;
                           initialstartbuy=0;
                        }
                     }
                     //iteration 4_5 end
                  }
                  //iteration 4_4 end
               }
               //iteration 4_2 end
            }
            //iteration 4_1 end
         }
         //iteration 2 ned
      }
      //iteration 1 end
   }
   //iteration 0 end
   
   prevtime=iTime(Symbol(),tf,0);
   return(0);
}
// Main Iteration End

//+------------------------------------------------------------------+

double GetLots(double price,string dir)
//GetLots Iteration Start
{
   int trades,factor;
   double retlot;

   for(int c=OrdersTotal()-1;c>=0;c--)
   {
      if(!OrderSelect(c,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
      {
         trades+=1;
      }
   }
      
   if(trades>=0 && trades<1)
	   retlot=lot1;
   if(trades>=1 && trades<2)
		retlot=lot2;
	if(trades>=2 && trades<3)
		retlot=lot3;
   if(trades>=3 && trades<4)
		retlot=lot4;
	if(trades>=4 && trades<5)
		retlot=lot5;
	if(trades>=5 && trades<6)
		retlot=lot6;
	if(trades>=6 && trades<7)
		retlot=lot7;
	if(trades>=7 && trades<8)
		retlot=lot8;
	if(trades>=8 && trades<9)
		retlot=lot9;
	if(trades>=9 && trades<10)
		retlot=lot10;
	if(trades>=10 && trades<11)
		retlot=lot11;
	if(trades>=11 && trades<12)
		retlot=lot12;
	if(trades>=12 && trades<13)
		retlot=lot13;
	if(trades>=13 && trades<14)
		retlot=lot14;
	if(trades>=14 && trades<15)
		retlot=lot15;
	if(trades>=15 && trades<16)
		retlot=lot16;
	if(trades>=16 && trades<17)
		retlot=lot17;
	if(trades>=17 && trades<18)
		retlot=lot18;
	if(trades>=18 && trades<19)
		retlot=lot19;
	if(trades>=19 && trades<20)
		retlot=lot20;
	if(trades>=20 && trades<21)
		retlot=lot21;
	if(trades>=21 && trades<22)
		retlot=lot22;
	if(trades>=22 && trades<23)
		retlot=lot23;
	if(trades>=23 && trades<24)
		retlot=lot24;
   if(trades>=24 && trades<25)
		retlot=lot25;
	if(trades>=25 && trades<26)
	   retlot=lot26;
	if(trades>=26 && trades<27)
		retlot=lot27;
	if(trades>=27 && trades<28)
		retlot=lot28;
	if(trades>=28 && trades<29)
		retlot=lot29;
	if(trades>=29 && trades<30)
		retlot=lot30;
	if(trades>=30 && trades<31)
		retlot=lot31;
	if(trades>=31 && trades<32)
		retlot=lot32;
	if(trades>=32 && trades<33)
		retlot=lot33;
	if(trades>=33 && trades<34)
		retlot=lot34;
	if(trades>=34 && trades<35)
		retlot=lot35;
	if(trades>=35 && trades<36)
	   retlot=lot36;
	if(trades>=36 && trades<37)
	   retlot=lot37;
	if(trades>=37 && trades<38)
	   retlot=lot38;
	if(trades>=38 && trades<39)
	   retlot=lot39;
	if(trades>=39 && trades<40)
	   retlot=lot40;
	if(trades>=40 && trades<41)
	   retlot=lot41;
	if(trades>=41)
	   retlot=lot42;

   return(retlot);
}
//GetLots Iteration End

//+------------------------------------------------------------------+
void CheckCloseTrades()
{
   bool closeonsell,closeonbuy;
   int runningpoints,numopen;
   double runningprofit;
   bool CloseTrades=false;
  
   closeonsell=false;
   closeonbuy=false;

   for(int a=OrdersTotal()-1;a>=0;a--)
   {
      if(!OrderSelect(a,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
      {
         if(OrderType()==OP_BUY)
         {
            runningpoints+=(Bid-OrderOpenPrice())/Point;
            runningprofit+=OrderProfit()+OrderCommission()+OrderSwap();
            closeonsell=true;
            numopen+=1;
         }
         if(OrderType()==OP_SELL)
         {
            runningpoints+=(OrderOpenPrice()-Bid)/Point;
            runningprofit+=OrderProfit()+OrderCommission()+OrderSwap();
            closeonbuy=true;
            numopen+=1;
         }
      }
   }

   if((runningprofit<=dollarsl && dollarsl<0) || (runningprofit>=dollartp && dollartp>0))// && dollarsl<0)
      CloseTrades=true;

   if((AccountEquity()<=(AccountBalance()+((AccountBalance()*percequitysl)/100)) && percequitysl<0) || (AccountEquity()>=(AccountBalance()+((AccountBalance()*percequitytp)/100)) && percequitytp>0))
      CloseTrades=true;

   if((runningpoints<=pointssl && pointssl<0) || (runningpoints>=pointstp && pointstp>0))
      CloseTrades=true;

   if(numopen>=closex && closex>0)
      CloseTrades=true;

   if(closeend)
   {
      if(iTime(Symbol(),1,0)>=StrToTime(close1) && (StrToTime(close1)-StrToTime(open1)>0))
      {
         CloseTrades=true;
      }
   }
      
   if((iCustom(Symbol(),tf,"Quantum",qdc,1,1)>0 && closeonsell==true && reverse==false && QT==1) || (iCustom(Symbol(),tf,"Quantum - Stochastic OB_OS",qdc,K,D,S,OS,OB,1,1)>0 && closeonsell==true && reverse==false && QT==2) || (iCustom(Symbol(),tf,"Quantum",qdc,0,1)>0 && closeonsell==true && reverse && QT==1) || (iCustom(Symbol(),tf,"Quantum - Stochastic OB_OS",qdc,K,D,S,OS,OB,0,1)>0 && closeonsell==true && reverse && QT==2) || (CloseTrades==true))
   {
      thewait=0;
      if(fifo==false)
      {
         if(CloseTrades)
            CloseNormal(1);
         if(CloseTrades==false)
            CloseNormal(0);
         int opens;
         for(int p=OrdersTotal()-1;p>=0;p--)
         {
            if(!OrderSelect(p,SELECT_BY_POS,MODE_TRADES))
               continue;
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
            {
               opens+=1;
            }
         }
         if(opens>0)
         {
            if(CloseTrades)
               CloseNormal(1);
            if(CloseTrades==false)
               CloseNormal(0);
         }
      }
      if(fifo==true)
      {
         if(CloseTrades)
            CloseFifo(1);
         if(CloseTrades==false)
            CloseFifo(0);
         int opens;
         for(int p=OrdersTotal()-1;p>=0;p--)
         {
            if(!OrderSelect(p,SELECT_BY_POS,MODE_TRADES))
               continue;
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
            {
               opens+=1;
            }
         }
         if(opens>0)
         {
            if(CloseTrades)
               CloseFifo(1);
            if(CloseTrades==false)
               CloseFifo(0);
         }
      }

      cycles+=1;

      if(iTime(Symbol(),1,0)>=open1 && iTime(Symbol(),1,0)<close1)
         c1+=1;
   }

   if((iCustom(Symbol(),tf,"Quantum",qdc,0,1)>0 && closeonbuy==true && reverse==false && QT==1) || (iCustom(Symbol(),tf,"Quantum - Stochastic OB_OS",qdc,K,D,S,OS,OB,0,1)>0 && closeonbuy==true && reverse==false && QT==2) || (iCustom(Symbol(),tf,"Quantum",qdc,1,1)>0 && closeonbuy==true && reverse && QT==1) || (iCustom(Symbol(),tf,"Quantum - Stochastic OB_OS",qdc,K,D,S,OS,OB,1,1)>0 && closeonbuy==true && reverse && QT==2) || (CloseTrades==true))
   {
      thewait=0;
      if(fifo==false)
      {
         if(CloseTrades)
            CloseNormal(1);
         if(CloseTrades==false)
            CloseNormal(0);
         int opens;
         for(int p=OrdersTotal()-1;p>=0;p--)
         {
            if(!OrderSelect(p,SELECT_BY_POS,MODE_TRADES))
               continue;
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
            {
               opens+=1;
            }
         }
         if(opens>0)
         {
            if(CloseTrades)
               CloseNormal(1);
            if(CloseTrades==false)
               CloseNormal(0);
         }
      }
      if(fifo==true)
      {
         if(CloseTrades)
            CloseFifo(1);
         if(CloseTrades==false)
            CloseFifo(0);
         int opens;
         for(int p=OrdersTotal()-1;p>=0;p--)
         {
            if(!OrderSelect(p,SELECT_BY_POS,MODE_TRADES))
               continue;
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
            {
               opens+=1;
            }
         }
         if(opens>0)
         {
            if(CloseTrades)
               CloseFifo(1);
            if(CloseTrades==false)
               CloseFifo(0);
         }
      }
         
      cycles+=1;

      if(iTime(Symbol(),1,0)>=open1 && iTime(Symbol(),1,0)<close1)
         c1+=1;
   }
   return;
}

//+------------------------------------------------------------------+
void CloseNormal(int A)
{
   prevorderprice=0;
   for(int c=OrdersTotal()-1;c>=0;c--)
   {
      if(!OrderSelect(c,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
      {
         if(A>0)
         {
            if(OrderType()==OP_BUY)
               buyclosed=true;
            if(OrderType()==OP_SELL)
               sellclosed=true;
         }
         RefreshRates();
         if(!OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,0))
            Alert("OrderClose Error: ",GetLastError());
      }
   }
}

//+------------------------------------------------------------------+
void CloseFifo(int B)
{
   prevorderprice=0;
   int TradeList2[][2];
   int ctTrade2=0;
   for(int h=OrdersTotal()-1;h>=0;h--)
   {
      if(!OrderSelect(h,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==mn)
         {
            ctTrade2++;
            ArrayResize(TradeList2,ctTrade2);
            TradeList2[ctTrade2-1][0]=OrderOpenTime();
            TradeList2[ctTrade2-1][1]=OrderTicket();
         }
   }
   ArraySort(TradeList2,WHOLE_ARRAY,0,MODE_ASCEND);
   for(int i=0; i<ctTrade2; i++)
   {
      OrderSelect(TradeList2[i][1],SELECT_BY_TICKET);
      if(B>0)
      {
         if(OrderType()==OP_BUY)
            buyclosed=true;
         if(OrderType()==OP_SELL)
            sellclosed=true;
      }
      RefreshRates();
      if(!OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,0))
         Alert("OrderClose Error: ",GetLastError());
   }
}