//+------------------------------------------------------------------+
//|                                                  Shaolin Quantum |
//|                                      Copyright 2015, Alex Lewis  |
//+------------------------------------------------------------------+ 
#property strict
enum enum_QT
  {
   Quantum=1,
   QuantumStochasticOB_OS=2,
  };
input int magic_num=2015; //Magic Number
input string time_open_str="00:00"; // Trading Window Start Time (GMT)
input string time_close_str="23:59"; // Trading Window End Time (GMT)
input int max_trades=0;//Max Trades per Trading Slot (0 unlimited)
input int max_cycles=1;//Max Cycles per Trading Slot (0 unlimited)
input enum_QT QT=2;//Quantum Indicator
input string zz=" Include QuantumStochasticOB_OS"  ;//If using QuantumStochasticOB_OS
input int K = 5;
input int D = 3;
input int S = 3;
input int OS = 20;
input int OB = 80;
input string yy="  Include Quantum"   ;//If using Quantum
input int qde=240;//Quantum eintDepth3 for Entry
input int qdc=240;//Quantum eintDepth3 for Close
input int slip=10;//Order Slippage
input int min_price_diff=0;//Minimum Points Between Trades (50 = 5 pips)
input string aaa="------------------- DISCLAIMER -----------------------";
input string aab="-- Grid Quantum EA can resulted to serious DrawDown --";
input string aac="--------- Set up lot size for trades -----------------";
input string aad="  reasonable minimum risk lot size ";
input string aae="	lot1=		";
input string aaf="	lot2=		";
input string aag="	lot3=		";
input string aah="	lot4=		";
input string aai="	lot5=		";
input string aaj="	lot6=		";
input string aak="	lot7=		";
input string aal="	lot8=		";
input string aam="	lot9=		";
input string aan="	lot10=	";
input string aao="	lot11=	";
input string aap="	lot12=	";
input string aaq="	lot13=	";
input string aar="	lot14=	";
input string aas="	lot15=	";
input string aat="	lot16=	";
input string aau="	lot17=	";
input string aav="	lot18=	";
input string aaw="	lot19=	";
input string aax="	lot20=	";
input string aay="	lot21=	";
input string aaz="	lot22=	";
input string nna="	lot23=	";
input string oob="	lot24=	";
input string ppc="	lot25=	";
input string qqd="	lot26=	";
input string rre="	lot27=	";
input string ssf="	lot28=	";
input string ttg="	lot29=	";
input string uuh="	lot30=	";
input string vvi="	lot31=	";
input string wwj="	lot32=	";
input string xxk="	lot33=	";
input string yyl="	lot34=	";
input string zzm="	lot35=	";
input string aba="	lot36&>= ";
input string aca="------------------------------------------------------";
input string ada="  reasonable medium risk lot size ";
input string aea="	lot1=		";
input string afa="	lot2=		";
input string aga="	lot3=		";
input string aha="	lot4=		";
input string aia="	lot5=		";
input string aja="	lot6=		";
input string aka="	lot7=		";
input string ala="	lot8=		";
input string ama="	lot9=		";
input string ana="	lot10=	";
input string aoa="	lot11=	";
input string apa="	lot12=	";
input string aqa="	lot13=	";
input string ara="	lot14=	";
input string asa="	lot15=	";
input string ata="	lot16=	";
input string aua="	lot17=	";
input string ava="	lot18=	";
input string awa="	lot19=	";
input string axa="	lot20=	";
input string aya="	lot21=	";
input string aza="	lot22=	";
input string baa="	lot23=	";
input string caa="	lot24=	";
input string daa="	lot25=	";
input string eaa="	lot26=	";
input string faa="	lot27=	";
input string gaa="	lot28=	";
input string haa="	lot29=	";
input string iaa="	lot30=	";
input string jaa="	lot31=	";
input string kaa="	lot32=	";
input string laa="	lot33=	";
input string maa="	lot34=	";
input string naa="	lot35=	";
input string oaa="	lot36&>= ";
input string pah="------------------------------------------------------";
input string qai="  reasonable high risk lot size ";
input string raa="	lot1=0.05	";
input string saa="	lot2=0.05	";
input string taa="	lot3=0.05	";
input string uaa="	lot4=0.05	";
input string vaa="	lot5=0.05	";
input string waa="	lot6=0.05	";
input string xaa="	lot7=0.05	";
input string yaa="	lot8=0.07	";
input string zaa="	lot9=0.07	";
input string bab="	lot10=0.07	";
input string cac="	lot11=0.07	";
input string dad="	lot12=0.07	";
input string eae="	lot13=0.07	";
input string faf="	lot14=0.07	";
input string gag="	lot15=0.07	";
input string hah="	lot16=0.1	";
input string iai="	lot17=0.1	";
input string jaj="	lot18=0.1	";
input string kak="	lot19=0.1	";
input string lal="	lot20=0.1	";
input string mam="	lot21=0.1	";
input string nan="	lot22=0.1	";
input string oao="	lot23=0.1	";
input string pap="	lot24=0.1	";
input string qaq="	lot25=0.1	";
input string rar="	lot26=0.13	";
input string sas="	lot27=0.13	";
input string tat="	lot28=0.13	";
input string uau="	lot29=0.13	";
input string vav="	lot30=0.13	";
input string waw="	lot31=0.13	";
input string xax="	lot32=0.13	";
input string yay="	lot33=0.13	";
input string zaz="	lot34=0.13	";
input string vvv="	lot35=0.13	";
input string www="	lot36&>=0.01";
input string xxx="------------------------------------------------------";
input string yyy="-------  CHOOSE LOT WISELY AND MARKET ENTRY    -------";
input string zzz="------------------------------------------------------";
input double lot1=0.05; //Lot Trade 1
input double lot2=0.05; //Lot Trade 2
input double lot3=0.05; //Lot Trade 3
input double lot4=0.05; //Lot Trade 4
input double lot5=0.05; //Lot Trade 5
input double lot6=0.05; //Lot Trade 6
input double lot7=0.05; //Lot Trade 7
input double lot8=0.07; //Lot Trade 8
input double lot9=0.07; //Lot Trade 9
input double lot10=0.07; //Lot Trade 10
input double lot11=0.07; //Lot Trade 11
input double lot12=0.07; //Lot Trade 12
input double lot13=0.07; //Lot Trade 13
input double lot14=0.07; //Lot Trade 14
input double lot15=0.07; //Lot Trade 15
input double lot16=0.1; //Lot Trade 16
input double lot17=0.1; //Lot Trade 17
input double lot18=0.1; //Lot Trade 18
input double lot19=0.1; //Lot Trade 19
input double lot20=0.1; //Lot Trade 20
input double lot21=0.1; //Lot Trade 21
input double lot22=0.1; //Lot Trade 22
input double lot23=0.1; //Lot Trade 23
input double lot24=0.1; //Lot Trade 24
input double lot25=0.1; //Lot Trade 25
input double lot26=0.13; //Lot Trade 26
input double lot27=0.13; //Lot Trade 27
input double lot28=0.13; //Lot Trade 28
input double lot29=0.13; //Lot Trade 29
input double lot30=0.13; //Lot Trade 30
input double lot31=0.13; //Lot Trade 31
input double lot32=0.13; //Lot Trade 32
input double lot33=0.13; //Lot Trade 33
input double lot34=0.13; //Lot Trade 34
input double lot35=0.13; //Lot Trade 35
input double lot36=0.01; //Lot Trade 36 & >
input double sl_pct=0;//% Equity Stop Loss For All Trades (positive number Eg 2.5)
input double tp_pct=0;//% Equity Take Profit For All Trades (positive number Eg 2.5)
input double sl_dollar=0;//$ Amount Stop Loss For All Trades (positive number Eg 100.00)
input double tp_dollar=0;//$ Amount Take Profit For All Trades (positive number Eg 100.00)
input int sl_points=500;// Stop Loss Points Per Trade
input int tp_points=0;// Take Profit Points Per Trade

int cycles = 0;
int trades = 0;
int trade_side = -1;
datetime day_curr;
datetime day_prev; 
int bars = Bars;
double lastTradePrice = 0;

int init()
{
   return 0;
}

int deinit()
{
   return 0;
}

int start()
{
   datetime currTime = TimeGMT();
   datetime time_open = StrToTime(time_open_str);
   datetime time_close = StrToTime(time_close_str);
   MqlDateTime dtct, dto, dtc;
   TimeToStruct(currTime, dtct);
   TimeToStruct(time_open, dto);
   TimeToStruct(time_close, dtc);
   dto.year = dtc.year = dtct.year;
   dto.mon = dtc.mon = dtct.mon;
   dto.day = dtc.day = dtct.day;
   time_open = StructToTime(dto);
   time_close = StructToTime(dtc);
   
   Comment("currTime: "+currTime+"\ntime_open: "+time_open+"\ntime_close: "+time_close);
   
   bool barNext = false;
   
   day_curr=iTime(Symbol(),PERIOD_D1,0);

   if(day_curr > day_prev)
   {
      cycles=0;
      day_prev=iTime(Symbol(),PERIOD_D1,0);
   }

   checkCloseTrades();
   
   if (Bars > bars) {
      bars = Bars;
      barNext = true;
   }

   if ((cycles < max_cycles || max_cycles == 0) && (trades < max_trades || max_trades == 0) && currTime >= time_open && currTime < time_close && barNext)
   {
      int nextTicket = -1;
      bool trade = false;
      double price = 0;
      double tp = 0, sl = 0;
      //buy
     if (QT==1)
     {
      if (iCustom(Symbol(),0,"Quantum",qde,0,1) > 0 && (trade_side == -1 || trade_side == OP_BUY)) 
      {
         trade_side = OP_BUY;
         trade = true;
         price = Ask;
         if (tp_points)
            tp = price + (tp_points*Point);
         if (sl_points)
            sl = price - (sl_points*Point);
      }
      else
      //sell
      if (iCustom(Symbol(),0,"Quantum",qde,1,1) > 0 && (trade_side == -1 || trade_side == OP_SELL)) 
      {
         trade_side = OP_SELL;
         trade = true;
         price = Bid;
         if (tp_points)
            tp = price - (tp_points*Point);
         if (sl_points)
            sl = price + (sl_points*Point);
      }
     }
     if (QT==2)
     {
      if (iCustom(Symbol(),0,"Quantum - Stochastic OB_OS",qde,K,D,S,OS,OB,0,1) > 0 && (trade_side == -1 || trade_side == OP_BUY)) 
      {
         trade_side = OP_BUY;
         trade = true;
         price = Ask;
         if (tp_points)
            tp = price + (tp_points*Point);
         if (sl_points)
            sl = price - (sl_points*Point);
      }
      else
      //sell
      if (iCustom(Symbol(),0,"Quantum - Stochastic OB_OS",qde,K,D,S,OS,OB,1,1) > 0 && (trade_side == -1 || trade_side == OP_SELL)) 
      {
         trade_side = OP_SELL;
         trade = true;
         price = Bid;
         if (tp_points)
            tp = price - (tp_points*Point);
         if (sl_points)
            sl = price + (sl_points*Point);
      }
     }
      //trade
      if (trade) 
      {
         //check minimum dist
         if (min_price_diff != 0) {
            double diff = MathAbs(price - lastTradePrice);
            if (diff < (min_price_diff*Point)) {
               Print("Minimum Price Diff Not Met: ",diff);
               return 0;
            }
         }
         
         nextTicket = OrderSend(Symbol(), trade_side, getLots(), price, slip, sl, tp, "SHAOLIN", magic_num, 0, 0);
         
         if(nextTicket <= -1) 
         {
            Print("OrderSend Error: ",GetLastError());
         } 
         else 
         {
            lastTradePrice = price;
            trades++;
         }
      }
   }
   
   return 0;
}

double getLots()
{
   double retlot = 0.01;

		if(trades>=0 && trades<1)
			retlot=lot1;
		if(trades>=1 && trades<2)
			retlot=lot2;
		if(trades>=2 && trades<3)
			retlot=lot3;
		if(trades>=3 && trades<4)
			retlot=lot4;
		if(trades>=4 && trades<5)
			retlot=lot5;
		if(trades>=5 && trades<6)
			retlot=lot6;
		if(trades>=6 && trades<7)
			retlot=lot7;
		if(trades>=7 && trades<8)
			retlot=lot8;
		if(trades>=8 && trades<9)
			retlot=lot9;
		if(trades>=9 && trades<10)
			retlot=lot10;
		if(trades>=10 && trades<11)
			retlot=lot11;
		if(trades>=11 && trades<12)
			retlot=lot12;
		if(trades>=12 && trades<13)
			retlot=lot13;
		if(trades>=13 && trades<14)
			retlot=lot14;
		if(trades>=14 && trades<15)
			retlot=lot15;
		if(trades>=15 && trades<16)
			retlot=lot16;
		if(trades>=16 && trades<17)
			retlot=lot17;
		if(trades>=17 && trades<18)
			retlot=lot18;
		if(trades>=18 && trades<19)
			retlot=lot19;
		if(trades>=19 && trades<20)
			retlot=lot20;
		if(trades>=20 && trades<21)
			retlot=lot21;
		if(trades>=21 && trades<22)
			retlot=lot22;
		if(trades>=22 && trades<23)
			retlot=lot23;
		if(trades>=23 && trades<24)
			retlot=lot24;
      if(trades>=24 && trades<25)
			retlot=lot25;
		if(trades>=25 && trades<26)
			retlot=lot26;
		if(trades>=26 && trades<27)
			retlot=lot27;
		if(trades>=27 && trades<28)
			retlot=lot28;
		if(trades>=28 && trades<29)
			retlot=lot29;
		if(trades>=29 && trades<30)
			retlot=lot30;
		if(trades>=30 && trades<31)
			retlot=lot31;
		if(trades>=31 && trades<32)
			retlot=lot32;
		if(trades>=32 && trades<33)
			retlot=lot33;
		if(trades>=33 && trades<34)
			retlot=lot34;
		if(trades>=34 && trades<35)
			retlot=lot35;
	   if(trades>=35)
	      retlot=lot36;
		
   return retlot;
}

void checkCloseTrades()
{
   bool close = false;

   if (trades > 0)
   {
      if((sl_pct > 0 && AccountEquity() <= (AccountBalance() - (AccountBalance() * (sl_pct/100)))) ||
         (sl_dollar > 0 && AccountEquity() <= (AccountBalance() - sl_dollar)))
      {
         close = true;
         Print("Stoploss Triggered");
      }
      else if((tp_pct > 0 && AccountEquity() >= (AccountBalance() + (AccountBalance() * (tp_pct/100)))) ||
         (tp_dollar > 0 && AccountEquity() >= (AccountBalance() + tp_dollar)))
      {
         close = true;
         Print("Take Profit Triggered");
      }
      else
      {
         if (QT==1)
         {
            close = (iCustom(Symbol(),0,"Quantum",qdc,1,1) > 0 && trade_side == OP_BUY) || (iCustom(Symbol(),0,"Quantum",qdc,0,1) > 0 && trade_side == OP_SELL);
         }
         if (QT==2)
         {
            close = (iCustom(Symbol(),0,"Quantum - Stochastic OB_OS",qdc,K,D,S,OS,OB,1,1) > 0 && trade_side == OP_BUY) || (iCustom(Symbol(),0,"Quantum - Stochastic OB_OS",qdc,K,D,S,OS,OB,0,1) > 0 && trade_side == OP_SELL);
         }   
      }
      
      if (close)
      {
         while (trades > 0)
         {          
            int tradeList[][2];  
            int size = 0;
            
            for(int h = OrdersTotal()-1; h >= 0; h--)
            {
               if(!OrderSelect(h,SELECT_BY_POS,MODE_TRADES))
                  continue;
               if(OrderSymbol() == Symbol() && OrderMagicNumber() == magic_num)
               {
                  size++;
                  ArrayResize(tradeList, size);
                  tradeList[size-1][0]=OrderOpenTime();
                  tradeList[size-1][1]=OrderTicket();
               }
            }
            
            if (size > 0)
            {
               ArraySort(tradeList);
               
               for(int i=0; i < size; i++)
               {
                  if (!OrderSelect(tradeList[i][1],SELECT_BY_TICKET))
                     continue;
                  if(OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),0,0))
                  {
                     trades--;
                  }
                  else
                  {
                     Print("OrderClose Error: ",GetLastError());
                  }
               }
            }
            else
            {
               trades = 0;
            }
         }
         cycles++;
         trade_side = -1;
         lastTradePrice = 0;
      }
   }
}